<template>
  <div class="app-container">
    <!-- 查询和其他操作 -->
    <div class="filter-container" style="margin: 10px 0 10px 0;">
      <el-button class="filter-item" type="primary" @click="handleAdd" icon="el-icon-edit"  justify="end">新增</el-button>
    </div>

    <el-table :data="tableData" style="width:100%" class="show_table" >
      <el-table-column label="编号" style="width:2%" align="center">
        <template slot-scope="scope">
          <span>{{scope.row.uid}}</span>
        </template>
      </el-table-column>
      <el-table-column label="标题" style="width:10%" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.title }}</span>
        </template>
      </el-table-column>

      <el-table-column label="图片地址" style="width:30%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <img  v-if="scope.row.imageUrl" :src="scope.row.imageUrl" style="width: 130px;height: 70px;"/>
        </template>
      </el-table-column>
      <el-table-column label="图片跳转地址" style="width:30%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.jumpUrl }}</span>
        </template>
      </el-table-column>
      <el-table-column label="权重" style="width:2%" :show-overflow-tooltip="true" align="center">
      <template slot-scope="scope">
        <span>{{ scope.row.sort }}</span>
      </template>
    </el-table-column>
      <el-table-column label="展示渠道" style="width:2%" :show-overflow-tooltip="true" :formatter="showSourceFomatt" align="center" prop="showSource">
      </el-table-column>
      <el-table-column label="创建时间" style="width:4%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="更新时间" style="width:4%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.updateTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="状态" style="width:4%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <el-switch v-model="scope.row.status"
                     :inactive-value="0"
                     :active-value="1"
                     active-text="启用"
                     inactive-text="停用"
                     active-color="#13CE66"
                     inactive-color="#FF4949"
                     @change="changeSwitch(scope.row)"/>
        </template>
      </el-table-column>
      <el-table-column label="操作" fixed="right" style="width:3%">
        <template slot-scope="scope" >
          <el-button @click="handleEdit(scope.row)" type="primary" size="small" >编辑</el-button>
        </template>
      </el-table-column>

    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>
    <!-- 添加或修改对话框 -->
    <el-dialog :title="title"  :close-on-click-modal="false" :visible.sync="dialogFormVisible" width="30%" :before-close="sortHandleClose" center>
      <el-form :model="form" :rules="rules" ref="form" label-width="auto">
        <el-form-item label="位置" :label-width="formLabelWidth" prop="bannerType">
          <el-select v-model="form.bannerType" placeholder="位置"  class="filter-item" style="width: 200px;">
            <el-option label="banner轮播位" value="1">banner轮播位</el-option>
            <el-option label="活动列表" value="2">活动列表</el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="标题" :label-width="formLabelWidth" prop="title">
          <el-input v-model="form.title" style="width:80%"></el-input>
        </el-form-item>
        <el-form-item label="图片" :label-width="formLabelWidth" prop="imageUrl">
          <div class="imgBody" v-if="form.imageUrl">
            <i class="el-icon-error inputClass" v-show="icon" @click="deletePhoto()" @mouseover="icon = true"></i>
            <img @mouseover="icon = true" @mouseout="icon = false" v-bind:src="form.imageUrl" style=" width: 100%;height: 100%;"/>
          </div>
          <el-upload  class="el-upload"
                      ref="upload"
                      name="filedatas"
                      :action="url"
                      list-type="picture-card"
                      :limit="1"
                      :data="otherData"
                      :on-success="fileSuccess"
                      :on-preview="handlePictureCardPreview"
                      :on-remove="handleRemove">
            <i class="el-icon-plus"></i>
          </el-upload>
        </el-form-item>
        <el-form-item label="目标地址" :label-width="formLabelWidth" prop="jumpUrl">
          <el-input v-model="form.jumpUrl" style="width:80%"></el-input>
        </el-form-item>
        <el-form-item label="打开方式" :label-width="formLabelWidth" prop="openFlag">
          <input type="radio" v-model="form.openFlag" value="1"> 外部浏览器 &nbsp;
          <input type="radio" v-model="form.openFlag" value="2">&nbsp;APP内部 &nbsp;
          <input type="radio" v-model="form.openFlag" value="3">&nbsp;熊猫内部 &nbsp;
        </el-form-item>
        <el-form-item label="排序权重" :label-width="formLabelWidth" prop="sort">
          <el-input v-model="form.sort" style="width:80%"></el-input>
        </el-form-item>
        <el-form-item label="展示渠道" :label-width="formLabelWidth" prop="showSource">
          <el-checkbox-group v-model="form.showSource">
            <el-checkbox @change="pushGroupCheckAll" >全选(默认)</el-checkbox>
            <el-checkbox label="1" value="1" style="margin-left: 10px">VVC</el-checkbox>
            <el-checkbox label="2" value="2" style="margin-left: 10px">XHL</el-checkbox>
            <el-checkbox label="3" value="3" style="margin-left: 10px">ZLT</el-checkbox>
          </el-checkbox-group>
        </el-form-item>
        <el-form-item label="状态" :label-width="formLabelWidth" prop="status">
          <input type="radio" v-model="form.status" value="0">&nbsp; 停用 &nbsp;
          <input type="radio" v-model="form.status" value="1">&nbsp; 使用中(默认) &nbsp;
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
    <el-dialog :visible.sync="atlasDialogPictureVisible" fullscreen style="text-align: center">
      <img :src="atlasDialogImageUrl" alt="">
    </el-dialog>
  </div>
</template>

<script>
  import {getBannerList,addBanner,editBanner} from "@/api/bannerManager";
  import AvatarCropper from '@/components/AvatarCropper';
  import { getToken } from '@/utils/auth'
  export default {
    components: {
      AvatarCropper
    },
    created() {
      this.getBannerManagerList();
      this.otherData = {
        source: "picture",
        userUid: "1",
        adminUid: "1",
        projectName: "blog",
        sortName: "admin",
        token: getToken()
      };
    },

    data() {
      return {
        direction: 'ltr',
        size: '100%',
        showImage: false,
        url: process.env.PICTURE_API + "/file/uploadPictures",
        atlasDialogImageUrl: "", //图片显示地址
        tableData: [],
        atlasTableData: [],//图集数据
        activeName:0,
        atlasData: [], //图集数据
        pictureData: [], //图片数据
        atlasQueryParams:{
          uid:null,
          name:null,
          sortName:null,
          sortUid:null,
          status:null,
          upCount:null,
          outCount:null
        },
        atlasForm:{
          uid: null,
        },
        form: {
          bannerType: null,
          title: null,
          imageUrl: null,
          fileUid: null,
          jumpUrl: null,
          openFlag: null,
          sort: null,
          status: null,
            showSource:[]
        },
        queryParams:{
        },
        title: null,
        isChange: false, // 表单内容是否改变
        changeCount: 0, // 改变计数器
        pictureUids: [], //图片uid集合
        resourceData: [], //标签数据
        tagValue: [], //保存选中标签id(编辑时)
        projectValue: null, //保存选中标签id(编辑时)
        tagData: [], //标签数据
        tagOptions: [], //标签候选框
        projectUid: null, //项目uid
        projectName: "全部", //项目名称
        projectOptions: [], //标签候选框
        multipleSelection: [], //多选，用于批量修改标签
        currentPage: 1,
        total: null,
        pageSize: 40,
        orderByDescColumn: "", // 降序字段
        orderByAscColumn: "", // 升序字段
        formLabelWidth: "120px", //弹框的label边框
        dialogFormVisible: false,
        atlasFormVisible: false,
        pictureFormVisible: false,
        atlasDialogPictureVisible: false,//当前分类图集列表
        isSortAdd: false,
        isEditForm: false,
        imageUrl: null,
        photoList: [],
        allProject:[],
          showSource:['1','2','3'],
        yesNoDictList: [], // 是否字典
        imagecropperKey: 0,
        imagecropperShow: false, //控制图片选择器的显示
        fileIds: "",
        icon: false, //控制删除图标的显示
        isFirstPhotoVisible: true, // 图片选择器是否首次显示【用于懒加载】
        rules: {
          bannerType: [
            {required: true, message: '位置不能为空', trigger: 'blur'},
          ],
          title: [
            {required: true, message: '标题不能为空', trigger: 'blur'},
            {min: 1, max: 150, message: '长度在1到150个字符'},
          ],
          jumpUrl: [
            {required: true, message: '目标地址不能为空', trigger: 'blur'},
          ],
          sort: [
            {required: true, message: '排序字段不能为空', trigger: 'blur'},
            {pattern: /^[0-9]\d*$/, message: '排序字段只能为自然数'},
          ],
          imageUrl: [
            {required: true, message: '图片不能为空', trigger: 'blur'},
          ],
          openFlag:[
            {required: true, message: '打开方式不能为空', trigger: 'blur'},
          ],
          status:[
            {required: true, message: '状态不能为空', trigger: 'blur'},
          ],
            showSource:[
                {required: true, message: '展示渠道不能为空', trigger: 'blur'},
            ]
        }
      };
    },

    methods: {
      getBannerManagerList: function() {
        this.queryParams.currentPage = this.currentPage;
        this.queryParams.pageSize = this.pageSize;
        this.queryParams.orderByDescColumn = this.orderByDescColumn
        this.queryParams.orderByAscColumn = this.orderByAscColumn
        getBannerList(this.queryParams).then(response => {
          this.tableData = response.data.records;
          this.currentPage = response.data.current;
          this.pageSize = response.data.size;
          this.total = response.data.total;
        });
      },
      changeSwitch: function(data){
        editBanner(data).then(response => {
          this.$commonUtil.message.success(response.message)
          this.dialogFormVisible = false;
          this.getGameManagerList();
        });
      },
      //点击单选
      checked: function(data) {
        let idIndex = this.pictureUids.indexOf(data.uid);
        if (idIndex >= 0) {
          //选过了
          this.pictureUids.splice(idIndex, 1);
        } else {
          this.pictureUids.push(data.uid);
        }
      },

      handleFind: function() {
        this.currentPage = 1
        this.getBannerManagerList();
      },
      getFormObject: function() {
        var formObject = {
          uid: null,
          bannerType: null,
          title: null,
          fileUid: null,
          openFlag: 1,
          status: 1,
          imageUrl: null,
          jumpUrl: null,
          sort: 0,
            showSource:[]
        };
        return formObject;
      },
      deletePhoto: function() {
        this.form.imageUrl = null;
        this.form.ava = "";
        this.icon = false;
      },
      checkPhoto() {
        this.photoList = [];
        this.fileUid = "";
        this.imagecropperShow = true;
        this.isFirstPhotoVisible = false
      },
        showSourceFomatt: function (row, column) {
          if(row.showSource !="" && row.showSource !=null && row.showSource != undefined){
              var result =[];
              var source = row.showSource.split(',');
              for (var i=0;i<source.length;i++) {
                 if(source[i]==='1'){
                     result.push("VVC");
                 }else if(source[i]==='2'){
                     result.push("XHY");
                 }else if(source[i]==='3'){
                     result.push("ZLT");
                 }
              }
              return  result.join(',');
          }
          return null;
        },
      /**
       * 翻页事件
       */
      handleSizeChange(val) {
        this.pageSize = val;
        this.getBannerManagerList();
      },
      //改变页码
      handleCurrentChange(val) {
        this.currentPage = val;
        this.getBannerManagerList();
      },
      sortHandleClose(){
        this.dialogFormVisible = false;
        this.$refs.form.clearValidate();
        this.getBannerManagerList();
      },

      handleRemove: function() {

      },
      //点击新增
      handleAdd: function() {
        this.title = "新增广告设置"
        this.isSortAdd = true
        this.dialogFormVisible = true;
        this.form = this.getFormObject();
        this.isEditForm = false;
      },
      //点击编辑
      handleEdit: function(row) {
        this.showImage=true;
        this.title = "编辑广告设置"
        this.isSortAdd = false;
        this.dialogFormVisible = true;
        this.isEditForm = true;
        this.form = row;
        this.form.showSource = row.showSource.split(',');
        // this.form.title = row.project.title;
        // this.from.openFlag = row.project.openFlag;
        // this.form.sort = row.project.sort;
      },
      handlePictureCardPreview(file) {
        this.atlasDialogPictureVisible = true;
        this.atlasDialogImageUrl = url
      },

      submitForm: function() {
        this.$refs.form.validate((valid) => {
          if(!valid) {
            console.log("校验出错")
          } else {
            if (this.isEditForm) {
                this.form.showSource = this.form.showSource.join(',');
              editBanner(this.form).then(response => {
                this.$commonUtil.message.success(response.message)
                this.dialogFormVisible = false;
                this.getBannerManagerList();
              });
            } else {
                this.form.showSource = this.form.showSource.join(',');
              addBanner(this.form).then(response => {
                if (response.code == this.$ECode.SUCCESS) {
                  this.$commonUtil.message.success(response.message)
                } else {
                  this.$commonUtil.message.error(response.message)
                }
                this.dialogFormVisible = false;
                this.getBannerManagerList();
              });
            }
          }
        })
      },

      fileSuccess (response) {
        this.showImage=false;
        if (response.code == this.$ECode.SUCCESS) {
          let file = response.data;
          let photoList = []
          photoList.push(file[0].url);
          this.imageUrl = file[0].url
          this.form.imageUrl = file[0].url;
          this.form.fileUid = file[0].uid;
          this.$refs.upload.clearFiles();
          this.photoList = []

        }

      },
      close() {
        this.imagecropperShow = false
      },

      deletePhoto: function() {
        this.form.imageUrl = null;
        this.form.ava = "";
        this.icon = false
      },
      checkPhoto() {
        this.photoList = [];
        this.fileUid = "";
        this.imagecropperShow = true;
      },
      setCover: function() {
        if (this.pictureUids.length != 1) {
          this.$commonUtil.message.error("选择一张图片设为封面图")
          return;
        }

        this.$confirm("是否将该图片设为封面？, 是否继续?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            let params = {};
            params.uid = this.pictureUids[0]
            params.pictureAtlasUid = this.atlasQueryParams.uid
            setCover(params).then(response => {
              this.$commonUtil.message.success(response.message)
              this.pictureUids = [];

              //再次查询图片
              this.pictureList();
            });
          })
          .catch(() => {
            this.$commonUtil.message.info("已取消")
          });
      },

        pushGroupCheckAll(checkAll) {
            if (checkAll) {
                this.showSource.forEach(value => {
                    if (this.form.showSource.indexOf(value) < 0) {
                        this.form.showSource.push(value);
                    }
                })
            } else {
                this.form.showSource = [];
            }
        },

    }
  }
</script>

<style scoped>
  .el-upload {
    border: 1px dashed #d9d9d9;
    border-radius: 6px;
    margin: 0, 0, 0, 10px;
    cursor: pointer;
    position: relative;
    overflow: hidden;
  }
  .el-upload:hover {
    border-color: #409eff;
  }
  .avatar-uploader-icon {
    font-size: 28px;
    color: #8c939d;
    width: 100px;
    height: 100px;
    line-height: 100px;
    text-align: center;
    border: 1px dashed #c0ccda;
    border-radius: 8px;
  }
  .inputClass {
    position: absolute;
  }
  .imgBody {
    width: 150px;
    height: 150px;
    border: solid 2px #ffffff;
    float: left;
    position: relative;
  }
  .uploadImgBody {
    margin-left: 5px;
    width: 100px;
    height: 100px;
    border: dashed 1px #c0c0c0;
    float: left;
    position: relative;
  }
  .uploadImgBody :hover {
    border: dashed 1px #00ccff;
  }
  .inputClass {
    position: absolute;
  }
  .show_table {
    background-color: #dde;
    width: 100%;
    height: 100%;
    overflow: auto;
    position: relative;
  }
</style>
